// This code is from a tutorial by William Adams, and was only
// slightly rewritten.

#ifndef GAMESTICK_H
#define GAMESTICK_H

#include <Joystick.h>
#include <SupportDefs.h>

class BTSGameStick {
public:
	// Constants for identifying joystick buttons.
	enum EButton {
		kButton1 = 1,
		kButton2 = 2
	};

	// Constructor.
	BTSGameStick(const char *pDeviceName = "joystick1");

	// Training methods.	
	void FindZero(float &x, float &y);
	void Train(void);
	void Update(void);

	// Inquiry methods.
	bool IsValid()
	{
		return mIsValid;
	}
	void GetPosition(float &x, float &y);
	void GetAbsolutePosition(short &x, short &y);
	void GetZeroPosition(short &x, short &y);
	bool IsButtonPressed(const int buttons);

private:
	BTSGameStick(const BTSGameStick &orig);
	BTSGameStick &operator =(const BTSGameStick &orig);

	//Data members.
	BJoystick mJoystick;
	bool mIsValid;
	float mZeroX;
	float mZeroY;
	float mMinX;
	float mMinY;
	float mMaxX;
	float mMaxY;
	
	float mMinXRange;
	float mMinYRange;
	float mMaxXRange;
	float mMaxYRange;
	float mLastX;
	float mLastY;
	bigtime_t mLastTimestamp;
};

#endif
