//	Copyright (c) Jens Kilian 1998
//
//	Permission to use, copy, modify, distribute, and sell this software and its
//	documentation for any purpose is hereby granted without fee, provided that
//	the above copyright notice appear in all copies and that both that
//	copyright notice and this permission notice appear in supporting
//	documentation, and that the name of the copyright holder not be used in
//	advertising or publicity pertaining to distribution of the software without
//	specific, written prior permission.  The copyright holder makes no
//	representations about the suitability of this software for any purpose.  It
//	is provided "as is" without express or implied warranty.
//
//	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
//	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
//	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
//	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
//	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//	PERFORMANCE OF THIS SOFTWARE.

// MIME types for BeZX.

#ifndef _BZX_ZXMIME_H
#define _BZX_ZXMIME_H

class BNode;

class ZXMimeTypes
{
public:
	// The various kinds of file known to BeZX.
	enum {
		kAnyFile = -1,			// none of our business
		
		kCartridgeFile = 0,	// Microdrive cartridge
		kDiskFile,				// Disk image
		kROMFile,				// ROM image
		kSaveFile,				// File generated by SAVE/LOAD trap
		kScreenFile,			// Screen dump
		kSnapshotFile,			// Snapshot (any format)
		
		kNumFileTypes
	};

	// Set a given file's type.
	static status_t SetFileType(const char *pName, int type);

	// Install types in the MIME database.
	static void Install(void);
	
private:
	ZXMimeTypes(void);
	ZXMimeTypes(const ZXMimeTypes &orig);
	ZXMimeTypes &operator =(const ZXMimeTypes &orig);
	~ZXMimeTypes(void);
};

#endif // _BZX_ZXMIME_H
