//	Copyright (c) Jens Kilian 1998
//
//	Permission to use, copy, modify, distribute, and sell this software and its
//	documentation for any purpose is hereby granted without fee, provided that
//	the above copyright notice appear in all copies and that both that
//	copyright notice and this permission notice appear in supporting
//	documentation, and that the name of the copyright holder not be used in
//	advertising or publicity pertaining to distribution of the software without
//	specific, written prior permission.  The copyright holder makes no
//	representations about the suitability of this software for any purpose.  It
//	is provided "as is" without express or implied warranty.
//
//	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
//	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
//	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
//	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
//	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
//	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//	PERFORMANCE OF THIS SOFTWARE.

// The window class for BeZX.

#ifndef _BZX_ZXWINDOW_H
#define _BZX_ZXWINDOW_H

#include <OS.h>
#include <Point.h>
#include <Window.h>

#include "ZXView.h"

class ZXWindow : public BWindow {
	typedef BWindow inherited;
public:
	
	// Constructor, destructor.
	ZXWindow(BPoint location, int32 argc, char **ppArgv);
	virtual ~ZXWindow(void);
	
	// Hook functions.
	virtual void FrameMoved(BPoint location);
	virtual bool QuitRequested(void);

private:
	ZXWindow(const ZXWindow &orig);
	ZXWindow &operator =(const ZXWindow &orig);
	
	// Thread functions.
	static int32 Emulate_(void *pData);
	int32 Emulate(void);
	
	// Data members.
	int32 mArgc;
	char **mppArgv;
	sem_id mEmulatorSem;
	thread_id mEmulatorThread;
};

#endif // _BZX_ZXWINDOW_H
